from config import *


class StartMenu:
    def __init__(self):
        self.walk_cycle = TimedCycle(5, (3, 3, 3, 3, 3), (200, 200, 200, 200, 200))
        self.chase_cycle1 = ReCycle(30, 0, 15)
        self.chase_cycle2 = ReCycle(30, 0)
        self.title_cycle1 = ReCycle(30, 0, 10)
        self.title_cycle2 = ReCycle(30, 0, 5)
        self.title_cycle3 = ReCycle(30, 0)
        self.dead = False
        self.dying = False
        self.progress = 0

    def draw(self):
        self.walk_cycle.tick()
        screen.fill((230, 230, 230))
        draw_at_frame((-110 + self.chase_cycle1.get() * 3, 150), "title_cop", self.walk_cycle.get_frame(), (256, 256))
        draw_at_frame((555 + self.chase_cycle2.get() * 3, 150), "title_target", self.walk_cycle.get_frame(), (256, 256))

        screen.blit(texture_lib["title"], (0, 0))

        screen.blit(texture_lib["title_top"], (150, 40 + self.title_cycle1.get()/2))
        screen.blit(texture_lib["title_text"], (150, 40 + self.title_cycle2.get()/2))
        screen.blit(texture_lib["title_bottom"], (150, 40 + self.title_cycle3.get()/2))

        screen.blit(texture_lib["start_button"], (300, 250))
        if 300 < pygame.mouse.get_pos()[0] < 500:
            if 250 < pygame.mouse.get_pos()[1] < 310:
                screen.blit(texture_lib["start_button_overlay"], (300, 250))
                if pygame.mouse.get_pressed(3)[0]:
                    self.dying = True

        pygame.display.flip()

    def draw_exit(self):
        self.progress += 8
        pygame.draw.rect(screen, (255, 255, 255),
                         pygame.Rect(400 - self.progress * 8/2, 250 - self.progress * 5/2,
                                     self.progress * 8, self.progress * 5))
        pygame.display.flip()
        if self.progress > 100:
            self.dead = True


    def start(self):
        while not self.dead:
            for event in pygame.event.get():
                handle_common_event(event)
            if self.dying:
                self.draw_exit()
            else:
                self.draw()
            clock.tick(30)
